#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <sys/un.h>
#include <sys/types.h>
#include <sys/socket.h>

//ERROR CODES:
//  1 not enough arguments
//  2 bind failed

int main(int argc, char *argv[]){
  if (argc < 2) return 1;
  struct sockaddr_un address; char outgoing; int sender, stdin = open("/dev/stdin", O_RDONLY);
  
  sender = socket(AF_UNIX, SOCK_STREAM, 0);
  address.sun_family = AF_UNIX;
  strncpy(address.sun_path, argv[1], sizeof(address.sun_path) - 1);

  if (connect(sender, (struct sockaddr *) &address, sizeof(struct sockaddr_un)) == -1) return 2;

  while (read(stdin, &outgoing, sizeof(char)) > 0) write(sender, &outgoing, sizeof(char));

  close(sender); return 0;
}
